#version 330

layout(location = 0) in vec4 position;
in vec2 uv;
in vec3 normal;
out vec2 fragmentUV;
out vec3 fragmentNormal;
out vec4 lightVertexPos;
out vec4 worldPos;
out vec3 screenPos;
out float camDist;
uniform mat4 transform;
uniform mat4 worldTrans;
uniform mat4 lightTransform;
uniform vec4 cameraPosition;

void main() {
	gl_Position = transform * position;

	screenPos = (gl_Position/gl_Position.w).xyz;

	worldPos = worldTrans * position;
	worldPos = worldPos / worldPos.w;

	camDist = length(worldPos - cameraPosition);
	lightVertexPos = normalize(lightTransform * position);
	lightVertexPos = lightVertexPos / lightVertexPos.w;
	fragmentUV = uv;
	fragmentNormal = normalize((worldTrans*vec4(normal, 0))).xyz;
}